Highlights:
   - **Android**
      - Add initial support of Android in GGUI (#3845) (by **Gabriel H**)
   - **Bug fixes**
      - Query device attribute when using cuda 11 and above (#3930) (by **Bo Qiao**)
   - **Language and syntax**
      - Initial matrix argument support for ti.kernel (#3905) (by **Xiangyun Yang**)
      - Enable dynamic indexing of matrix field elements when possible (#3865) (by **Yi Xu**)
   - **Miscellaneous**
      - Support logging on Android platforms (#3849) (by **Gabriel H**)
   - **Refactor**
      - Remove all occurrences of print_preprocessed and print_ast (#3911) (by **Xiangyun Yang**)
      - Deprecate excepthook and completely remove _taichi_skip_traceback (#3902) (by **Haidong Lan**)
   - **Tests**
      - Add initial AOT CPP test (#3850) (#3899) (by **Gabriel H**)
      - Add initial AOT CPP test (#3850) (by **Gabriel H**)

Full changelog:
   - fix the ttf path (#3931) (by **Xiangyun Yang**)
   - [Bug] [cuda] Query device attribute when using cuda 11 and above (#3930) (by **Bo Qiao**)
   - [refactor] Optimize vector and matrix ndarray fill (#3921) (by **Bo Qiao**)
   - [opt] [ir] [refactor] Remove exceptions from offload pass (#3925) (by **Xiangyun Yang**)
   - [opt] [refactor] Remove the variable_optimization pass (#3927) (by **Mingkuan Xu**)
   - [doc] Add a tutorial: Run Ndarray Taichi program (#3908) (by **Vissidarte-Herman**)
   - [opt] [ir] [refactor] Remove exceptions from lower_ast pass (#3916) (by **Xiangyun Yang**)
   - [cuda] Use cuMemsetD32 to fill scalar ndarray (#3907) (by **Bo Qiao**)
   - [ci] Add self-hosted Windows buildbot for GPU testing (#3852) (by **Frost Ming**)
   - [Lang] Initial matrix argument support for ti.kernel (#3905) (by **Xiangyun Yang**)
   - [doc] Add example of color_edit_3 (#3919) (by **Vineyo**)
   - [perf] Clear global_vars/matrix_fields after materialize() (#3914) (by **Yi Xu**)
   - [gui] Update camera.py (#3898) (by **stamnug**)
   - [bug] Enable field-related checks in materialize() not only in first call (#3906) (by **Yi Xu**)
   - [Refactor] Remove all occurrences of print_preprocessed and print_ast (#3911) (by **Xiangyun Yang**)
   - [perf] Avoid using property for simple attributes to reduce python overhead. (by **Ailing Zhang**)
   - [opengl] Respect max_block_dim in ti.init (by **Ailing Zhang**)
   - [dx11] Add DX11 device interface definition (#3880) (by **quadpixels**)
   - [Refactor] Deprecate excepthook and completely remove _taichi_skip_traceback (#3902) (by **Haidong Lan**)
   - [opengl] Optimize range_for for ndarrays (by **Ailing Zhang**)
   - [Test] [aot] Add initial AOT CPP test (#3850) (#3899) (by **Gabriel H**)
   - [refactor] Merge taichi/lang/linalg_impl.py into _funcs.py (by **Ailing Zhang**)
   - [refactor] Remove import taichi in taichi/lang/quant_impl.py (by **Ailing Zhang**)
   - [refactor] Remove import taichi in taichi/lang/util.py (by **Ailing Zhang**)
   - [cuda] Increase saturating grid dim to reduce tail effect (#3855) (by **Bo Qiao**)
   - [opengl] Reduce repeated read to args buffer. (by **Ailing Zhang**)
   - [refactor] Remove import taichi from lang/__init__.py (#3889) (by **Yi Xu**)
   - Revert "[Test][aot] Add initial AOT CPP test (#3850)" (#3890) (by **Ye Kuang**)
   - [Android] [gui] Add initial support of Android in GGUI (#3845) (by **Gabriel H**)
   - [Test][aot] Add initial AOT CPP test (#3850) (by **Gabriel H**)
   - [Lang] Enable dynamic indexing of matrix field elements when possible (#3865) (by **Yi Xu**)
   - [cuda] Hide debug info (#3878) (by **Ye Kuang**)
   - [refactor] Remove legacy helper functions for testing (#3874) (by **Yi Xu**)
   - [refactor] Remove import taichi from expr.py (#3871) (by **Yi Xu**)
   - [refactor] Remove import taichi from field.py (#3870) (by **Yi Xu**)
   - [refactor] Remove import taichi from mesh.py (#3869) (by **Yi Xu**)
   - [refactor] Remove import taichi in ast_transformer (#3827) (by **lin-hitonami**)
   - [refactor] Remove import taichi from struct.py (#3866) (by **lin-hitonami**)
   - [autodiff] Provide stmt name for auto-diff related assert info (#3864) (by **Mingrui Zhang**)
   - [lang] Cleanup parallel sort utility (#3858) (by **Dunfan Lu**)
   - [refactor] Enforce destruction order of OpenGlRuntime. (#3861) (by **Ailing**)
   - [refactor] Add _MatrixFieldElement class (#3862) (by **Yi Xu**)
   - [opt] Add more accurate alias analysis for ExternalPtrStmt (#3859) (by **Yi Xu**)
   - [mesh] A small fix for mesh loop syntax in python frontend (#3836) (by **bx2k**)
   - [test] Add more complicated tests for building and destroying SNodeTrees (#3415) (by **ysh329**)
   - [lang] Calculate dynamic indexing strides of matrix field elements (#3854) (by **Yi Xu**)
   - [bug] Fix autodiff for ceil. (#3844) (by **Ailing**)
   - [refactor] Remove import taichi in matrix.py (#3842) (by **lin-hitonami**)
   - [Misc] [android] Support logging on Android platforms (#3849) (by **Gabriel H**)
   - [opengl] Allocate new arg bufs per kernel launch (#3848) (by **Ailing**)
   - [opengl] Only sync per ti.kernel when there's external array arg. (by **Ailing Zhang**)
   - [refactor] Rename is_external_array -> is_array and arr_bufs_ -> ext_arr_bufs_ (by **Ailing Zhang**)
   - [opengl] Only bind buffers per ti.kernel. (by **Ailing Zhang**)
   - [misc] Version bump: v0.8.8 -> v0.8.9 (#3846) (by **Yi Xu**)
